%% from http://lsr.dsi.unimi.it/LSR/Snippet?id=610

% PYTHON'S RANGE FUNCTION...UN-SCHEME-IC...I KNOW I KNOW...
#(define (range in_l n1 n2)
   (if (>= (length in_l) (- n2 n1))
       in_l
       (begin
	 (set! in_l (append in_l (list (+ n1 (length in_l)))))
	 (range in_l n1 n2))))

% TAKES A LIST AND UNLACES IT INTO LACES OF LACE_LEN
% SIMILAR TO UNLACING A MULTI-CHANNEL AUDIO FILE
% IE (unlace (list 1 2 3 4 5 6 7 8) 2) BECOMES ((1 5) (2 6) (3 7) (4 8))
% AND (unlace (list 1 2 3 4 5 6 7 8) 4) BECOMES ((1 3 5 7) (2 4 6 8))
#(define (unlace in_l out_l lace_len)
   (let ((laces (/ (length in_l) lace_len)))
     (if (eqv? (length out_l) lace_len)
       out_l
       (begin
	   (set! out_l 
	     (append out_l
	       (list 
		  (map 
		      (lambda (q) (list-ref in_l (+ (length out_l) (* q lace_len) ) ))
		      (range '() 0 laces)))))
	   (unlace in_l out_l lace_len)))))

% RELACES AN UNLACED LIST
#(define (lace in_l out_l)
   (if (eqv? (length out_l)
	     (* (length (car in_l))
	      (length in_l)))
       out_l
       (begin
	 (set! out_l 
	         (append out_l
		         (map 
			  (lambda (q) (list-ref q (/ (length out_l) (length in_l))))
			  in_l)))
	 (lace in_l out_l))))

% FUNCTION THAT RETURNS APPROPRIATE ENDPOINTS OF BEZIER CURVES TO CREATE SMOOTH TRANSITIONS BETWEEN PIECES
#(define (return_ends in_l out_l)
   (let ((minilen (- (length (car in_l)) 1))
	   (curlen (/ (length out_l) 2)))
     (if (eqv? (length out_l) (* 2 minilen))
       out_l
       (begin
	   (set! out_l 
	     (append out_l
	       (list
		  (+ (* (list-ref (list-ref in_l 4) curlen)
		      (- (list-ref (list-ref in_l 0) (+ curlen 1))
		          (list-ref (list-ref in_l 2) curlen)))
		        (list-ref (list-ref in_l 2) curlen))

		  (+ (* (list-ref (list-ref in_l 4) curlen)
		      (- (list-ref (list-ref in_l 1) (+ curlen 1))
		          (list-ref (list-ref in_l 3) curlen)))
		        (list-ref (list-ref in_l 3) curlen)))))
	   (return_ends in_l out_l)))))

% RETURNS THE LIST INDEX OF THE FIRST VALUE IN IN_L THAT IS GREATER THAN OR EQUAL TO N
#(define (gteq_index in_l n count)
   (if (or
	(eqv? count (length in_l)) (>= (list-ref in_l count) n))
       count
       (gt_index in_l n (+ count 1))))


% RETURNS THE LIST INDEX OF THE FIRST VALUE IN IN_L THAT IS GREATER THAN OR EQUAL TO N
#(define (gt_index in_l n count)
   (if
    (or
     (eqv? count (length in_l)) (> (list-ref in_l count) n))
    count
    (gt_index in_l n (+ count 1))))

% SHAVES OFF THE FIRST N VALUES OF A LIST. C IS A COUNTER
#(define (shave in_l n c)
   (if (eqv? n c)
       in_l
       (begin
	 (set! in_l (cdr in_l))
	 (shave in_l n (+ c 1)))))

% EXPANDS INTERM NOTIMES
% (exp_l 10 4 '())
% (10 10 10 10)
#(define (exp_l interm notimes out_l)
   (if (eqv? (length out_l) notimes)
       out_l
       (begin
	 (set! out_l (append out_l (list interm)))
	 (exp_l interm notimes out_l))))

% CALCULATES THE LEFT SIDE OF A SPLIT CUBIC BEZIER CURVE
#(define (lside in_l split)
   (let ((scratch (map car in_l))
	  (npl '())
	  (span 0)
	  (offset 0)
	  (time 0))
     (set! span (- (list-ref scratch 6) (list-ref scratch 0)))
     (set! offset (list-ref scratch 0))
     (set! time (/ (- split offset) span))
     (set! scratch (lace (list (map (lambda (q) (/ (- q offset) span)) (list-ref (unlace scratch '() 2) 0)) (list-ref (unlace scratch '() 2) 1)) '()))
     (if (eqv? split (caar in_l))
       in_l
       (begin
	   (set! npl 
	     (list 
	        time
	        (+ (* (expt (- 1 time) 3) (list-ref scratch 1)) (+ (* 3 (* time (* (expt (- 1 time) 2) (list-ref scratch 3)))) (+ (* 3 (* (- 1 time) (* (expt time 2) (list-ref scratch 5)))) (* (expt time 3) (list-ref scratch 7)))))
	        (+ (* (expt (- 1 time) 2) (list-ref scratch 2)) (+ (* 2 (* time (* (- 1 time) (list-ref scratch 4)))) (* (expt time 2) (list-ref scratch 6))))
	        (+ (* (expt (- 1 time) 2) (list-ref scratch 3)) (+ (* 2 (* time (* (- 1 time) (list-ref scratch 5)))) (* (expt time 2) (list-ref scratch 7))))
	        (+ (* (- 1 time) (list-ref scratch 4)) (* time (list-ref scratch 6)))
	        (+ (* (- 1 time) (list-ref scratch 5)) (* time (list-ref scratch 7)))
	        (list-ref scratch 6)
	        (list-ref scratch 7)
	        )
	     )
	   (set! npl (lace (list (map (lambda (q) (+ (* q span) offset)) (list-ref (unlace npl '() 2) 0)) (list-ref (unlace npl '() 2) 1)) '()))
	   (map (lambda (x y) (cons y (cdr x)) ) in_l npl)))))

% CALCULATES THE RIGHT SIDE OF A SPLIT CUBIC BEZIER CURVE
#(define
   (rside in_l split)
   (let* ((scratch (map (lambda (q) (car (reverse q))) in_l))
	    (npl '())
	    (span 0)
	    (offset 0)
	    (time 0))
     (set! span (- (list-ref scratch 6) (list-ref scratch 0)))
     (set! offset (list-ref scratch 0))
     (set! time (/ (- split offset) span))
     (set! scratch (lace (list (map (lambda (q) (/ (- q offset) span)) (list-ref (unlace scratch '() 2) 0)) (list-ref (unlace scratch '() 2) 1)) '()))
     (if
      (eqv? split (caar in_l))
      in_l
      (begin
       (set! npl 
	      (list 
	              (list-ref scratch 0)
	              (list-ref scratch 1)
	              (+ (* (- 1 time) (list-ref scratch 0)) (* time (list-ref scratch 2)))
	              (+ (* (- 1 time) (list-ref scratch 1)) (* time (list-ref scratch 3)))
	              (+ (* (expt (- 1 time) 2) (list-ref scratch 0)) (+ (* 2 (* time (* (- 1 time) (list-ref scratch 2)))) (* (expt time 2) (list-ref scratch 4))))
	              (+ (* (expt (- 1 time) 2) (list-ref scratch 1)) (+ (* 2 (* time (* (- 1 time) (list-ref scratch 3)))) (* (expt time 2) (list-ref scratch 5))))
	              time
	              (+ (* (expt (- 1 time) 3) (list-ref scratch 1)) (+ (* 3 (* time (* (expt (- 1 time) 2) (list-ref scratch 3)))) (+ (* 3 (* (- 1 time) (* (expt time 2) (list-ref scratch 5)))) (* (expt time 3) (list-ref scratch 7)))))
	              ))
       (set! npl (lace (list (map (lambda (q) (+ (* q span) offset)) (list-ref (unlace npl '() 2) 0)) (list-ref (unlace npl '() 2) 1)) '()))
       (map (lambda (x y) (reverse (cons y (cdr (reverse x)))) ) in_l npl)))))


% STRETCHES X TO A GIVEN SPAN AFTER MOVING IT BY OFFSET.  AT THE END, MOVES BY O2
#(define (x_to_span in_l out_l span offset o2)
   (if (eqv? (length in_l) 0)
       out_l
       (begin
	 (set! out_l (append out_l (append (list (map (lambda (q) (+ o2 (* (- q offset) span))) (car in_l))) (list (cadr in_l)))))
	 (x_to_span (cddr in_l) out_l span offset o2))))

% USED TO TURN A LIST OF NUMBERS INTO A STRING
#(define (numl_s in_l out_s)
   (if (eqv? (length in_l) 0)
       out_s
       (begin
	 (set! out_s (string-append out_s (number->string (car in_l)) " "))
	 (numl_s (cdr in_l) out_s))))

% GENERATES A CURVETO LINE
#(define (curveto in_l)
   (string-append (numl_s in_l "") " curveto\n"))

% GENERATES ALL CURVETO LINES
#(define (allcurves in_l out_s)
   (if (eqv? (length (car in_l)) 0)
       out_s
       (allcurves (map cdr in_l) (string-append out_s (curveto (map (lambda (q) (car q)) in_l))))))

% MAKES THE POSTSCRIPT STRING
#(define (make_ps in_l xspan lw offset)
   (let* ((frontmatter 
	      (string-append 
	           "gsave
currentpoint translate
" (number->string lw) " setlinewidth
newpath
" (number->string (+ offset (caar in_l))) " " (number->string (caadr in_l)) " moveto\n"
	       )
	      )
	    (backmatter "stroke
grestore"))
     (set! in_l (x_to_span in_l '() xspan 0 offset))
     (set! in_l (cddr in_l))
     (string-append frontmatter (allcurves in_l "") backmatter)))

% THE BIG DADDY - MAKES THE APPROPRIATE BEZIER CURVES FOR A GIVEN RANGE USING ALL THE ABOVE FUNCTIONS
#(define (splitcurve prim_l rg_l)
   (let* ((unlaced_l '())
	    (point_ll '())
	    (point_rl '())
	    (canonical_l '())
	    (split_l '())
	  ; POINT HOLDERS
	    (x 0)
	    (y 0)
	  ; FOR ITERATION
	    (i 0)
	    (j 0)
	    (r '())
	  ; BOOLEAN FOR ADDING
	    (addbool #f)
	  ; BOUNDARY POINTS FOR RANGE
	    (lbound 0)
	    (rbound 0)
	    )
     (set! prim_l (append prim_l '(0.0)))
    ;(format #t "STEP 1: PRIM_L APPENDED ~a\n" prim_l)
     (set! r (range '() 0 (- (/ (length prim_l) 5) 1)))
     (set! unlaced_l (unlace prim_l '() 5))
    ;(format #t "STEP 2: PRIM_L UNLACED ~a\n" unlaced_l)
     (set! point_ll (return_ends unlaced_l '()))
     (set! point_ll (append (list 0.0 0.0) point_ll))
    ;(format #t "STEP 3.1: POINT_LL CREATED ~a\n" point_ll)
     (set! point_ll (unlace point_ll '() 2))
    ;(format #t "STEP 3.2: POINT_LL UNLACED ~a\n" point_ll)
     (set! point_rl (return_ends unlaced_l '()))
     (set! point_rl (append point_rl (list 1.0 0.0)))
    ;(format #t "STEP 3.3: POINT_RL UNLACED ~a\n" point_rl)
     (set! point_rl (unlace point_rl '() 2))
    ;(format #t "STEP 3.4: POINT_RL UNLACED ~a\n" point_rl)
     (set! canonical_l (append point_ll (append (reverse (cdr (reverse unlaced_l))) point_rl)))
    ;(format #t "STEP 4: CANONICAL L CREATED ~a\n" canonical_l)
     (set! lbound (gt_index (list-ref canonical_l 6) (car rg_l) 0))
     (set! rbound (- (length (list-ref canonical_l 0)) (gt_index (list-ref canonical_l 0) (car (reverse rg_l)) 0) ))
    ;(format #t "STEP 5: BOUNDS FOUND ~a ~a\n" lbound rbound)
     (set! canonical_l (map shave canonical_l (exp_l lbound (length canonical_l) '()) (exp_l 0 (length canonical_l) '())))
     (set! canonical_l (map reverse (map shave (map reverse canonical_l) (exp_l rbound (length canonical_l) '()) (exp_l 0 (length canonical_l) '()))))
    ;(format #t "STEP 6: CANONICAL L SHAVED ~a\n" canonical_l)
     (set! canonical_l (lside canonical_l (car rg_l)))
     (set! canonical_l (rside canonical_l (car (reverse rg_l))))
    ;(format #t "STEP 7: CANONICAL L CHANGED ~a\n" canonical_l)
     (x_to_span canonical_l '() (/ 1.0 (- (car (reverse (list-ref canonical_l 6))) (caar canonical_l))) (caar canonical_l) 0)))

% SOME USAGE STUFF
%#(define a (splitcurve '(0.1 1. 0.2 1. 0.4 0.5 -0.8 0.7 -0.3 0.9 0.9 0.5 0.91 0.7) '(0.05 0.8)))
%#(define b (make_ps a 100 0.5 30))

#(define VIBRATO_RUNNING_SUM 0.0)

% FUNCTION CALCULATING THE FULL LENGTH OF THE VIBRATO
#(define (calcfull siblings count)
   (if (eqv? (length siblings) 0)
       count
       (calcfull (cdr siblings) (+ count (- (cdr (ly:grob-property (car siblings) 'X-extent)) (car (ly:grob-property (car siblings) 'X-extent)))))))

% FUNCTION THAT MAKES THE VIBRATO
% CALLS SPLITCURVE, MAKE_PS
#(define (makevib grob in_l span full thick) 
   (let* ((xbeg (car span))
	    (xend (cdr span))
	    (xspan (- xend xbeg))
	    (cequilfautfaire 0))
     (set! cequilfautfaire (splitcurve in_l (list (/ VIBRATO_RUNNING_SUM full) (/ (+ VIBRATO_RUNNING_SUM xspan) full)) ))
     (set! VIBRATO_RUNNING_SUM (+ xspan VIBRATO_RUNNING_SUM))
     (ly:make-stencil (list 'embedded-ps (make_ps cequilfautfaire xspan thick xbeg)) (cons 0 0) (cons 0 0))))

% CALLBACK FUNCTION - THE MASTER
% CALLS MAKEVIB, CALCFULL
#(define (vibcallback grob in_l)
   (let* ((orig (ly:grob-original grob))
	    (span (ly:grob-property grob 'X-extent)) 
	    (siblings (if (ly:grob? orig) (ly:spanner-broken-into orig) '()))
	    (full 0)
	    (thick (car (reverse in_l))))
     (if (>= (length siblings) 2) 
       (set! full (calcfull siblings 0))
       (set! full (- (cdr span) (car span))))
     (set! in_l (reverse (cdr (reverse in_l))))
     (ly:grob-set-property! grob 'stencil (makevib grob in_l span full thick))
     (if (>= (length siblings) 2)
       (if
	  (eqv? grob (car (reverse siblings)))
	  (set! VIBRATO_RUNNING_SUM 0.0))
       (set! VIBRATO_RUNNING_SUM 0.0))))

vibster = #(define-music-function (parser location in_l) (list?)
	         #{
	           \once \override Voice . Hairpin #'after-line-breaking = #(lambda (grob)
									       (vibcallback grob $in_l))
		          #})


