var socket = io.connect();

function startChr() { socket.emit("startChr")}
function clearStopwatch() { socket.emit("clearStopwatch")}
function goStopwatch() { socket.emit("goStopwatch")}
function stopChr() { socket.emit("stopChr")}
function resetChr() { socket.emit("resetChr")}
function stopWatch(state) { socket.emit("stopWatch", state)}

// update the stopwatch value on the client page in line with server
socket.on("chronFromServer", function(chron) {
    $("div#timer").text(chron);
});

var scorewidth = "-10000px"
var scorewidtha = "-20000px"

speed = 600
speeda = speed/2
speedb = speed/2.5
speedc = speed/3
speedd = speed/3.5

var tlx = new TimelineMax();
var tlplaya = new TimelineMax({repeat:100, yoyo:true});

var tla = new TimelineMax({repeat:100});
var tlb = new TimelineMax({repeat:100});
var tlc = new TimelineMax({repeat:100});
var tld = new TimelineMax({repeat:100});

tlx.to(title, 1.5, {css:{left:"40px"}},1.5);
tlx.to(ensemble, 1, {css:{left:"320px"}},-0.5);
tlx.to(robcanning, 1, {css:{left:"420px"}},-0.5);

tlx.to(title, 3, {css:{left:"-1300px"}},2);
tlx.to(ensemble, 3, {css:{top:"-300px"}},-3);
tlx.to(robcanning, 3, {css:{left:"820px"}},-3);
tlx.to(playzonea, 0.5, {css:{top:"18px"}});
tlx.to(playzoneb, 0.5, {css:{top:"200px"}});
tlx.to(playzonec, 0.5, {css:{top:"378px"}});
tlx.to(playzoned, 0.5, {css:{top:"558px"}});

tla.insert("positiona", 10);
tlb.insert("positiona", 20);
tlc.insert("positiona", 30);
tld.insert("positiona", 40);

var initialwait = 0

////////////////////////////////////////////////////////
// send poistion data to server for retramsmit via OSC
/////////////////////////////////////////////////////////
//TweenLite.ticker.addEventListener("tick", tickHandler);

function tickHandler() {
/*
    //get score part locations and send data to server
    var lefta = $('#scoresvga').css("left");  
    socket.emit("parta", lefta)
    var leftb = $('#scoresvgb').css("left");
    socket.emit("partb", leftb)
    var leftc = $('#scoresvgc').css("left");
    socket.emit("partc", leftc)
    var leftd = $('#scoresvgd').css("left");
    socket.emit("partd", leftd)
*/
}

tla.to(scoresvga, speeda, {css:{left:scorewidth},ease:Linear.easeNone,onUpdate:tickHandler},initialwait);
tla.to(scoresvga1, speeda, {css:{left:"0px"},ease:Linear.easeNone},-speeda);
tla.to(scoresvga1, speedd, {css:{left:scorewidth},ease:Linear.easeNone});
tla.to(scoresvga2, speedd, {css:{left:"0px"},ease:Linear.easeNone},-speedd);
tla.to(scoresvga2, speedc, {css:{left:scorewidth},ease:Linear.easeNone});
tla.to(scoresvga3, speedc, {css:{left:"0px"},ease:Linear.easeNone},-speedc)
tla.to(scoresvga3, speedb, {css:{left:scorewidth},ease:Linear.easeNone});
tla.to(scoresvga4, speedb, {css:{left:"0px"},ease:Linear.easeNone},-speedb);

tlb.to(scoresvgb, speedb, {css:{left:scorewidth},ease:Linear.easeNone},initialwait+4);
tlb.to(scoresvgb1, speedb, {css:{left:"0px"},ease:Linear.easeNone},-speedb);
tlb.to(scoresvgb1, speedc, {css:{left:scorewidth},ease:Linear.easeNone});
tlb.to(scoresvgb2, speedc, {css:{left:"0px"},ease:Linear.easeNone},-speedc);
tlb.to(scoresvgb2, speedd, {css:{left:scorewidth},ease:Linear.easeNone});
tlb.to(scoresvgb3, speedd, {css:{left:"0px"},ease:Linear.easeNone},-speedd);
tlb.to(scoresvgb3, speeda, {css:{left:scorewidth},ease:Linear.easeNone});
tlb.to(scoresvgb4, speeda, {css:{left:"0px"},ease:Linear.easeNone},-speeda);

tlc.to(scoresvgc, speedc, {css:{left:scorewidth},ease:Linear.easeNone},initialwait+8);
tlc.to(scoresvgc1,speedc, {css:{left:"0px"},ease:Linear.easeNone},-speedc);
tlc.to(scoresvgc1, speedb, {css:{left:scorewidth},ease:Linear.easeNone});
tlc.to(scoresvgc2,speedb, {css:{left:"0px"},ease:Linear.easeNone},-speedb);
tlc.to(scoresvgc2, speeda, {css:{left:scorewidth},ease:Linear.easeNone});
tlc.to(scoresvgc3,speeda, {css:{left:"0px"},ease:Linear.easeNone},-speeda);
tlc.to(scoresvgc3, speedd, {css:{left:scorewidth},ease:Linear.easeNone});
tlc.to(scoresvgc4,speedd, {css:{left:"0px"},ease:Linear.easeNone},-speedd);


tld.to(scoresvgd, speedd, {css:{left:scorewidth},ease:Linear.easeNone},initialwait+12);
tld.to(scoresvgd1,speedd, {css:{left:"0px"},ease:Linear.easeNone},-speedd);
tld.to(scoresvgd1, speeda, {css:{left:scorewidth},ease:Linear.easeNone});
tld.to(scoresvgd2,speeda, {css:{left:"0px"},ease:Linear.easeNone},-speeda);
tld.to(scoresvgd2, speedb, {css:{left:scorewidth},ease:Linear.easeNone});
tld.to(scoresvgd3,speedb, {css:{left:"0px"},ease:Linear.easeNone},-speedb);
tld.to(scoresvgd3, speedc, {css:{left:scorewidth},ease:Linear.easeNone});
tld.to(scoresvgd4,speedc, {css:{left:"0px"},ease:Linear.easeNone},-speedc);

$('#playzonea').toggle(function(){tla.pause();},function(){tla.play(); } );
$('#playzoneb').toggle(function(){tlb.pause();},function(){tlb.play(); } );
$('#playzonec').toggle(function(){tlc.pause();},function(){tlc.play(); } );
$('#playzoned').toggle(function(){tld.pause();},function(){tld.play(); } );

$("#help").mouseover(function() {
    $("#helpcontent").show();
}).mouseout(function() { 
    $("#helpcontent").hide();
});

$(document).keydown(function(e){
   
    if (e.keyCode==190 ){
	tla.pause(); tlb.pause();tlc.pause();tld.pause();
    }
});


$(document).keydown(function(e){
   
    if (e.keyCode==188 ){
	tla.resume(); tlb.resume();tlc.resume();tld.resume();
    }
   
});

$(document).keydown(function(e){
   
    if (e.keyCode==48 ){ clearStopwatch(); goStopwatch();
	tla.gotoAndStop(93); setTimeout(function(){tla.play()},10000); 
	tlb.gotoAndStop(21); setTimeout(function(){tlb.play()},30000); 
	tlc.gotoAndStop(2); setTimeout(function(){tlc.play()},50000); 
	tld.gotoAndStop(37); setTimeout(function(){tld.play()},60000); 
    }
   
});

$(document).keydown(function(e){
   
    if (e.keyCode==32 ){
	tla.play(); tlb.play();tlc.play();tld.play();
    }
   
});

$(document).keydown(function(e){
   
    if (e.keyCode==49 ){tla.pause();}
    if (e.keyCode==50 ){tlb.pause();}
    if (e.keyCode==51 ){tlc.pause();}
    if (e.keyCode==52 ){tld.pause();}
});

$(document).keyup(function(e){
   
    if (e.keyCode==49 ){tla.resume();}
    if (e.keyCode==50 ){tlb.resume();}
    if (e.keyCode==51 ){tlc.resume();}
    if (e.keyCode==52 ){tld.resume();}
});

var av = 1;
function aplayspeed(xspeed){
    if (xspeed == 1){ av += 0.1; }
    else if (xspeed == -1){ av -= 0.1; }
    return av;
}

var bv = 1;
function bplayspeed(xspeed){
    if (xspeed == 1){ bv += 0.1; }
    else if (xspeed == -1){ bv -= 0.1; }
    return bv;
}

var cv = 1;
function cplayspeed(xspeed){
    if (xspeed == 1){ cv += 0.1; }
    else if (xspeed == -1){ cv -= 0.1; }
    return cv;
}

var dv = 1;
function dplayspeed(xspeed){
    if (xspeed == 1){ dv += 0.1; }
    else if (xspeed == -1){ dv -= 0.1; }
    return dv;
}









